// generated by: arc -uRNMLP -A ../../libargile -A ../../argrt -o std_class.c -H std_class.h -m std_class.argl std_class.arg 
#include "std_class.h"

#line 110 "std_class.arg"
static class_t * new_class(argile_code_t *, argile_code_t *, argile_def_t *, argile_type_t);
/** :new class <argile code scope> <argile code code> <def> <argile type type>: -> class **/
#line 118 "std_class.arg"
static void del(class_t *);
/** :del <class c>: -> nothing **/
#line 131 "std_class.arg"
static argile_type_t dig_class_type(argile_shovel_t *, argile_call_t *, argile_code_t *, ...);
/** :dig class type <shovel sh> <call> (<argile code code>): -> argile type **/
#line 158 "std_class.arg"
static int compile_class_code(argile_shovel_t *, argile_call_t *, argile_code_t *);
/** :compile class code <shovel sh> <call> <argile code code>: -> int **/
#line 195 "std_class.arg"
static void mark_processed(argile_list_t *);
/** :mark <list of (match) lm> processed: -> nothing **/
#line 237 "std_class.arg"
static int syntax_error(argile_call_t *);
/** :syntax error <call c>: -> int **/

#line 31 "std_class.arg"
int argmod_class_defmaker = 1;
#line 33 "std_class.arg"
char( argmod_class_doc[]) = {"Define a class type; takes a word or syntax parameter for the name, and a\ncode block that must contain only calls to :<type> <word field> (/<nat>):\n(the natural option specifies the number of bits for the field).\nIf a field has a raw value class type, then the sub class is\nincluded in the current (field by content instead of field by pointer).\nAn optional type parameter can be used to specify a parent class, that\nmakes an implicit field named `_parent_' (so it can't be used for other\nfields). If the bind option `union' is specified, it will make an union\ninstead of a class (in this case, the parent type will be ignored).\nIf the bind option `extern' is set, the type will not be defined in C.\nSyntax requirements:\n  :<word> <code>:\n  :<syntax> <code>:\n  :{<word>|<syntax>} (<type>) <code>:\n"};

#line 51 "std_class.arg"
void argmod_class_compile(argile_call_t * p_argile_call)
/** :argmod_class_compile <call>: -> nothing **/
{
#line 53 "std_class.arg"
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_type_t class_type;
#line 54 "std_class.arg"
  argile_type_t parent;

#line 52 "std_class.arg"
  if ((argile_def_has_option((p_argile_call)->def, "union"))) {
#line 470 "../../argrt/std.argl"
    return;
  } //;
#line 53 "std_class.arg"
  sh = argile_shovel_new(p_argile_call);
#line 55 "std_class.arg"
  class_type = dig_class_type(sh, p_argile_call, ((argile_code_t *)0));
  if ((class_type != ARGILE_TYPE_NOTHING)) {
    argile_match_t * m = ((argile_match_t *)0);

#line 57 "std_class.arg"
    m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0);
    if ((m)) {
      parent = argile_match_eval_type(m);
      if ((parent != ARGILE_TYPE_NOTHING)) {
#line 62 "std_class.arg"
        argile_type_info_t * info = ((argile_type_info_t *)0);
        unsigned char is_class;

#line 62 "std_class.arg"
        info = argile_type_get_info(parent);
        is_class = ((info != NULL) && ((info)->ttype == ARGILE_TYPE_KIND_CLASS));
        info = argile_type_get_info(class_type);
        if (((info) && ((info)->ttype == ARGILE_TYPE_KIND_CLASS))) {
          argile_field_t * f = ((argile_field_t *)0);

#line 66 "std_class.arg"
          f = argile_field_new((((int)(((int)parent) & ((1 << 30) - 1))) | (1 << 30)), class_type, "_parent_");
          if (!(is_class)) {
#line 470 "../../argrt/std.argl"
            parent = (((int)(((int)parent) & ((1 << 30) - 1))) | (1 << 31));
          } //;
#line 68 "std_class.arg"
          argile_list_prepend(&(((info)->tval).t_class).fields, argile_list_new(f, (void *)&argile_field_del));
          argile_list_prepend(&(info)->casters, argile_list_new(argile_type_caster_new(parent, ((argile_code_t *)0)), (void *)&argile_type_caster_del));
        } //;
      } //;
    } //;
  } //;
#line 70 "std_class.arg"
  argile_shovel_del(sh);
}

#line 72 "std_class.arg"
int argmod_class_reject(argile_call_t * p_argile_call_2)
/** :argmod_class_reject <call>: -> int **/
{
#line 74 "std_class.arg"
  int reject = 0;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_match_t * m = ((argile_match_t *)0);

#line 75 "std_class.arg"
  sh = argile_shovel_new(p_argile_call_2);
  m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0);
  if ((m)) {
    argile_type_t type;

#line 78 "std_class.arg"
    type = argile_match_eval_type(m);
    if ((((((int)type) >> 31) & 1))) {
      argile_shovel_del(sh);
      return argile_call_add_reject(p_argile_call_2, "std/class: ""parent type is by reference");
    } //;
#line 82 "std_class.arg"
    if ((((((int)type) >> 30) & 1))) {
      argile_shovel_del(sh);
      return argile_call_add_reject(p_argile_call_2, "std/class: ""parent type is by raw value");
    } //;
  } //;
#line 85 "std_class.arg"
  m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_CODE, (char *)0);
  if ((m)) {
    argile_code_t * code = ((argile_code_t *)0);

#line 87 "std_class.arg"
    code = argile_match_eval_code(m);
    if ((code)) {
      reject = compile_class_code(sh, p_argile_call_2, code);
    } //;
#line 90 "std_class.arg"
    else {
      reject = argile_call_add_reject(p_argile_call_2, "std/class: ""code parameter is not constant");
    };
  } //;
#line 92 "std_class.arg"
  argile_shovel_del(sh);
  return reject;
}

#line 95 "std_class.arg"
argile_type_t argmod_class_gettype(argile_call_t * p_argile_call_3)
/** :argmod_class_gettype <call>: -> argile type **/
{
#line 96 "std_class.arg"
  return ((((p_argile_call_3)->owner)) ? (ARGILE_TYPE_TYPE) : (ARGILE_TYPE_NOTHING));
}

#line 98 "std_class.arg"
void argmod_class_gencode(argile_call_t * p_argile_call_4)
/** :argmod_class_gencode <call>: -> nothing **/
{
#line 100 "std_class.arg"
  argile_type_t t;

#line 99 "std_class.arg"
  if ((((p_argile_call_4)->data == NULL) || ((p_argile_call_4)->owner == NULL))) {
#line 470 "../../argrt/std.argl"
    return;
  } //;
#line 100 "std_class.arg"
  t = (((class_t *)(p_argile_call_4)->data))->type;
  argile_type_gen_prefix(t);
  argile_type_gen_suffix(t);
}

#line 110 "std_class.arg"
static class_t * new_class(argile_code_t * scope, argile_code_t * code, argile_def_t * p_argile_def, argile_type_t type)
/** :new class <argile code scope> <argile code code> <def> <argile type type>: -> class **/
{
#line 111 "std_class.arg"
  class_t * c = ((class_t *)0);

#line 111 "std_class.arg"
  c = ((class_t *)memset(argile_dbg_malloc(sizeof(class_t)), 0, sizeof(class_t)));
  (c)->scope = scope;
  (c)->code = code;
  (c)->def = p_argile_def;
  (c)->type = type;
  return c;
}

#line 118 "std_class.arg"
static void del(class_t * c)
/** :del <class c>: -> nothing **/
{
#line 122 "std_class.arg"
  argile_list_t * ld;

#line 119 "std_class.arg"
  if (((c)->code)) {
    argile_list_t * lc;

#line 120 "std_class.arg"
    lc = ((c)->code)->calls;
    for (; (lc); lc = ((argile_list_t *)lc)->next) {
#line 121 "std_class.arg"
      (*((argile_call_t * *)&((argile_list_t *)lc)->data))->def = ((argile_def_t *)0);
    };
  } //;
#line 122 "std_class.arg"
  ld = argile_list_search(((c)->scope)->defs, (c)->def, ((argile_comparer_t)0));
  if ((ld)) {
    if ((((argile_list_t *)ld)->next == NULL)) {
      ((c)->scope)->defs_tail = ((argile_list_t *)ld)->prev;
    } //;
#line 126 "std_class.arg"
    argile_list_rm(&((c)->scope)->defs, ld);
    ((argile_list_t *)ld)->prev = ((argile_list_t *)0);
#line 127 "std_class.arg"
    ((argile_list_t *)ld)->next = ((argile_list_t *)0);
    argile_list_del(ld);
  } //;
#line 129 "std_class.arg"
  argile_dbg_free(c);
}

#line 131 "std_class.arg"
static argile_type_t dig_class_type(argile_shovel_t * sh, argile_call_t * p_argile_call_5, argile_code_t * code_2, ...)
/** :dig class type <shovel sh> <call> (<argile code code>): -> argile type **/
{
#line 133 "std_class.arg"
  argile_list_t * syn = ((argile_list_t *)0);
  unsigned char del_syn;
  argile_match_t * m = ((argile_match_t *)0);

#line 132 "std_class.arg"
  if (!(((p_argile_call_5)->data == NULL))) {
#line 470 "../../argrt/std.argl"
    return (((class_t *)(p_argile_call_5)->data))->type;
  } //;
#line 134 "std_class.arg"
  del_syn = 0;
#line 136 "std_class.arg"
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0))) {
    syn = argile_match_eval_syntax(m);
    del_syn = 0;
  } //;
#line 139 "std_class.arg"
  else if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0))) {
    char * word = "";

#line 140 "std_class.arg"
    if (((word = argile_match_eval_word(m)))) {
      syn = argile_list_new(argile_syntax_new(ARGILE_SYN_WORD, argile_dbg_strdup(word)), (void *)&argile_syntax_del);
      del_syn = 1;
    } //;
  } //;
#line 143 "std_class.arg"
  if ((syn)) {
    argile_type_t type_2;
    argile_type_info_t * info = ((argile_type_info_t *)0);
#line 147 "std_class.arg"
    argile_def_t * d = ((argile_def_t *)0);

#line 144 "std_class.arg"
    type_2 = argile_type_new();
    info = argile_type_set_info(type_2, ARGILE_TYPE_KIND_BIND);
    (info)->ext = (argile_def_has_option((p_argile_call_5)->def, "extern"));
    d = argile_def_new(syn, ((int)del_syn), (argile_type_t)ARGILE_TYPE_TYPE, p_argile_call_5, ARGILE_DEF_TYPE, ((void *)((long)type_2)));
#line 149 "std_class.arg"
    (d)->ext = (info)->ext;
    argile_code_def((p_argile_call_5)->scope, d, 1);
    (p_argile_call_5)->data = new_class((p_argile_call_5)->scope, code_2, d, type_2);
    (p_argile_call_5)->del = (void *)&del;
    (p_argile_call_5)->keep_data = 1;
    return type_2;
  } //;
#line 155 "std_class.arg"
  argile_die_at(p_argile_call_5, "std/class: ""no name or syntax for new type");
  return ARGILE_TYPE_NOTHING;
}

#line 158 "std_class.arg"
static int compile_class_code(argile_shovel_t * sh_2, argile_call_t * p_argile_call_6, argile_code_t * code_3)
/** :compile class code <shovel sh> <call> <argile code code>: -> int **/
{
#line 159 "std_class.arg"
  argile_type_t class_type;
#line 165 "std_class.arg"
  unsigned char is_union;
  argile_type_kind_t type_kind;
  argile_list_t * fields;
  argile_type_info_t * info = ((argile_type_info_t *)0);
#line 186 "std_class.arg"
  argile_list_t * lc;

#line 159 "std_class.arg"
  class_type = dig_class_type(sh_2, p_argile_call_6, code_3);
  if ((class_type == ARGILE_TYPE_NOTHING)) {
    return 1;
  } //;
#line 162 "std_class.arg"
  if (((code_3)->calls == NULL)) {
    argile_die_at(p_argile_call_6, "std/class: ""no fields");
    return 1;
  } //;
#line 165 "std_class.arg"
  is_union = (argile_def_has_option((p_argile_call_6)->def, "union"));
  type_kind = ((is_union) ? (ARGILE_TYPE_KIND_UNION) : (ARGILE_TYPE_KIND_CLASS));
#line 168 "std_class.arg"
  info = argile_type_get_info(class_type);
  if (((info) && ((info)->ttype == type_kind))) {
    if (is_union) {
      fields = (((info)->tval).t_union).variants;
    } //;
#line 172 "std_class.arg"
    else {
      fields = (((info)->tval).t_class).fields;
    };
  } //;
#line 174 "std_class.arg"
  else {
    int i = 0;

#line 175 "std_class.arg"
    i = argile_list_count((code_3)->calls);
    fields = ((argile_list_t *)0);
    while (((i)-- > 0)) {
      argile_field_t * f = ((argile_field_t *)0);

#line 178 "std_class.arg"
      f = argile_field_new((argile_type_t)ARGILE_TYPE_NOTHING, class_type, (char *)0);
      argile_list_prepend(&fields, argile_list_new(f, (void *)&argile_field_del));
    };
#line 180 "std_class.arg"
    info = argile_type_set_info(class_type, type_kind);
    if (is_union) {
      (((info)->tval).t_union).variants = fields;
    } //;
#line 183 "std_class.arg"
    else {
      (((info)->tval).t_class).fields = fields;
    };
  };
#line 187 "std_class.arg"
  for (lc = (code_3)->calls; ((lc) && (fields)); lc = ((argile_list_t *)lc)->next,fields = ((argile_list_t *)fields)->next) {
    argile_call_t * c_2 = ((argile_call_t *)0);
    argile_list_t * lm;
    unsigned char val;
#line 190 "std_class.arg"
    int bits = 0;
#line 192 "std_class.arg"
    argile_type_t type_2;
    char * name = (char *)0;

#line 188 "std_class.arg"
    c_2 = *((argile_call_t * *)&((argile_list_t *)lc)->data);
    lm = (c_2)->match;
    val = 0;
    if (((c_2)->def)) {
#line 470 "../../argrt/std.argl"
      continue;
    } //;
#line 192 "std_class.arg"
    type_2 = (argile_type_t)ARGILE_TYPE_NOTHING;
#line 194 "std_class.arg"
    mark_processed(lm);
#line 200 "std_class.arg"
    if (((lm) && (((argile_list_t *)lm)->next))) {
      argile_list_t * end;
      argile_match_t * m = ((argile_match_t *)0);

#line 201 "std_class.arg"
      end = argile_list_end(lm);
      m = *((argile_match_t * *)&((argile_list_t *)end)->data);
      if (((m) && ((m)->type == ARGILE_MATCH_CONS))) {
        int err = 0;

#line 204 "std_class.arg"
        bits = argile_match_eval_int(m, &err);
        if ((err != 0)) {
#line 470 "../../argrt/std.argl"
          return syntax_error(c_2);
        } //;
#line 206 "std_class.arg"
        if ((bits < 1)) {
          argile_die_at(c_2, "std/class: ""number of field bits must be > 0");
          return 1;
        } //;
#line 209 "std_class.arg"
        if ((bits >= (1 << 16))) {
          bits = 0xffff;
        } //;
#line 211 "std_class.arg"
        end = ((argile_list_t *)end)->prev;
        if ((end == NULL)) {
#line 470 "../../argrt/std.argl"
          return syntax_error(c_2);
        } //;
#line 213 "std_class.arg"
        m = *((argile_match_t * *)&((argile_list_t *)end)->data);
        if ((((m == NULL) || ((m)->type != ARGILE_MATCH_OP)) || (strcmp(((m)->value).op, "/") != 0))) {
          return syntax_error(c_2);
        } //;
#line 216 "std_class.arg"
        end = ((argile_list_t *)end)->prev;
        if ((end == NULL)) {
#line 470 "../../argrt/std.argl"
          return syntax_error(c_2);
        } //;
#line 218 "std_class.arg"
        m = *((argile_match_t * *)&((argile_list_t *)end)->data);
      } //;
#line 219 "std_class.arg"
      if (((m) && ((m)->type == ARGILE_MATCH_WORD))) {
#line 221 "std_class.arg"
        unsigned char compiled;

#line 220 "std_class.arg"
        argile_list_unlink(((argile_list_t *)end)->prev, end);
        compiled = 0;
        if ((argile_type_compile(&type_2, lm, code_3, p_argile_call_6, &(c_2)->def, &lm))) {
          (c_2)->match = lm;
          (c_2)->compiled = 1;
          compiled = 1;
          ((argile).curcall)++;
          name = ((m)->value).word;
          if ((((((int)type_2) >> 30) & 1))) {
            val = 1;
            type_2 = (((int)type_2) & ((1 << 30) - 1));
          } //;
        } //;
#line 231 "std_class.arg"
        argile_list_link(argile_list_end((c_2)->match), end);
        if (!(compiled)) {
          return argile_call_add_reject(p_argile_call_6, "std/class: ""could not compile type yet");
        } //;
      } //;
#line 235 "std_class.arg"
      else {
        return syntax_error(c_2);
      };
    } //;
#line 241 "std_class.arg"
    if ((name)) {
      argile_field_t * f = ((argile_field_t *)0);

#line 242 "std_class.arg"
      f = *((argile_field_t * *)&((argile_list_t *)fields)->data);
      if (!(((f)->name == NULL))) {
#line 470 "../../argrt/std.argl"
        argile_dbg_free((f)->name);
      } //;
#line 244 "std_class.arg"
      (f)->name = argile_dbg_strdup(name);
      (f)->type = type_2;
      (f)->bits = ((unsigned int)bits);
      if (((val && (info = argile_type_get_info(type_2))) && ((info)->ttype == ARGILE_TYPE_KIND_CLASS))) {
#line 249 "std_class.arg"
        (f)->type = (((int)(((int)(f)->type) & ((1 << 30) - 1))) | (1 << 30));
      } //;
    } //;
#line 250 "std_class.arg"
    else {
      return syntax_error(c_2);
    };
  };
#line 252 "std_class.arg"
  (code_3)->compiled = 1;
  return 0;
}

#line 195 "std_class.arg"
static void mark_processed(argile_list_t * lm_2)
/** :mark <list of (match) lm> processed: -> nothing **/
{
#line 196 "std_class.arg"
  for (; (lm_2); lm_2 = ((argile_list_t *)lm_2)->next) {
    if ((*((argile_match_t * *)&((argile_list_t *)lm_2)->data))) {
      (*((argile_match_t * *)&((argile_list_t *)lm_2)->data))->processed = 1;
    } //;
  };
}

#line 237 "std_class.arg"
static int syntax_error(argile_call_t * c_3)
/** :syntax error <call c>: -> int **/
{
#line 238 "std_class.arg"
  argile_die_at(c_3, "std/class: ""syntax in body is :<type> <word> (/<nat>):");
  return 1;
}

