// generated by: arc -uRNMLP -A ../../libargile -A ../../argrt -o std_extern.c -H std_extern.h -m std_extern.argl std_extern.arg 
#include "std_extern.h"

#line 27 "std_extern.arg"
char( argmod_extern_doc[]) = {"Make an external definition with a C identifier (word), a syntax and\noptionnally a type. If a syntax is specified, a function is defined,\nif not, a variable is defined with the identifier as syntax.\nIf no identifier is specified, the syntax must begin by a word which\nwill be used as identifier.\nIf the binding option `nodecl' is specified, no declaration will be\ngenerated.\nSyntax requirements:\n  :<word> <syntax> (<type>):\n  :{<word>|<syntax>} (<type>):\n"};
#line 41 "std_extern.arg"
int argmod_extern_defmaker = 1;

int argmod_extern_reject(argile_call_t * p_argile_call)
/** :argmod_extern_reject <call>: -> int **/
{
#line 45 "std_extern.arg"
  argile_match_t * m = ((argile_match_t *)0);
  argile_list_t * syn = ((argile_list_t *)0);
  argile_type_t type;
  char * ident = (char *)0;
#line 50 "std_extern.arg"
  argile_shovel_t * sh = ((argile_shovel_t *)0);

#line 47 "std_extern.arg"
  type = (argile_type_t)ARGILE_TYPE_NOTHING;
#line 50 "std_extern.arg"
  sh = argile_shovel_new(p_argile_call);
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0))) {
    type = argile_match_eval_type(m);
  } //;
#line 53 "std_extern.arg"
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0))) {
    ident = argile_match_eval_word(m);
  } //;
#line 55 "std_extern.arg"
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0))) {
    syn = argile_match_eval_syntax(m);
  } //;
#line 57 "std_extern.arg"
  argile_shovel_del(sh);
#line 59 "std_extern.arg"
  if (((syn == NULL) && (ident == NULL))) {
    return argile_call_add_reject(p_argile_call, "std/extern: ""no identifier and no syntax were given");
  } //;
#line 61 "std_extern.arg"
  if (((syn == NULL) && (type == ARGILE_TYPE_NOTHING))) {
    return argile_call_add_reject(p_argile_call, "std/extern: ""can't define a variable with type nothing");
  } //;
#line 63 "std_extern.arg"
  return 0;
}

#line 65 "std_extern.arg"
void argmod_extern_compile(argile_call_t * p_argile_call_2)
/** :argmod_extern_compile <call>: -> nothing **/
{
#line 66 "std_extern.arg"
  argile_match_t * m = ((argile_match_t *)0);
  argile_list_t * syn = ((argile_list_t *)0);
  argile_type_t type;
  char * ident = (char *)0;
#line 71 "std_extern.arg"
  unsigned char nodecl;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
#line 84 "std_extern.arg"
  argile_def_t * def = ((argile_def_t *)0);
#line 104 "std_extern.arg"
  unsigned int id = 0;

#line 68 "std_extern.arg"
  type = (argile_type_t)ARGILE_TYPE_NOTHING;
#line 71 "std_extern.arg"
  nodecl = (argile_def_has_option((p_argile_call_2)->def, "nodecl"));
  sh = argile_shovel_new(p_argile_call_2);
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0))) {
    type = argile_match_eval_type(m);
  } //;
#line 75 "std_extern.arg"
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0))) {
    ident = argile_match_eval_word(m);
  } //;
#line 77 "std_extern.arg"
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0))) {
    syn = argile_match_eval_syntax(m);
  } //;
#line 79 "std_extern.arg"
  argile_shovel_del(sh);
#line 81 "std_extern.arg"
  if (((syn == NULL) && (ident == NULL))) {
    return;
  } //;
#line 85 "std_extern.arg"
  if ((syn == NULL)) {
    if ((type == ARGILE_TYPE_NOTHING)) {
#line 470 "../../argrt/std.argl"
      return;
    } //;
#line 87 "std_extern.arg"
    syn = argile_list_new(argile_syntax_new(ARGILE_SYN_WORD, argile_dbg_strdup(ident)), (void *)&argile_syntax_del);
    def = argile_def_new(syn, 1, (((((((int)type) >> 30) & 1))) ? (type) : ((((int)(((int)type) & ((1 << 30) - 1))) | (1 << 31)))), p_argile_call_2, ARGILE_DEF_VAR, argile_var_new(type, ((argile_match_t *)0)));
  } //;
  else {
    if ((ident == NULL)) {
      argile_syntax_t * s = ((argile_syntax_t *)0);

#line 92 "std_extern.arg"
      s = *((argile_syntax_t * *)&((argile_list_t *)syn)->data);
      if (((s)->type != ARGILE_SYN_WORD)) {
        argile_die_at(p_argile_call_2, "std/extern: ""syntax must start by a word");
        return;
      } //;
#line 96 "std_extern.arg"
      ident = ((s)->value).syn_word;
    } //;
#line 97 "std_extern.arg"
    def = argile_def_new(syn, 0, type, p_argile_call_2, ARGILE_DEF_FUNC, NULL);
  };
  argile_code_def((p_argile_call_2)->scope, def, 1);
  (p_argile_call_2)->data = def;
  (def)->ext = 1;
  (def)->nodecl = nodecl;
  (def)->genid = argile_dbg_strdup(ident);
  id = (argile_hash(ident) % 1024);
  if ((argile_list_search(((argile).ids)[id], ident, (void *)&argile_streq) == NULL)) {
    argile_list_prepend(&((argile).ids)[id], argile_list_new(ident, ((argile_deleter_t)0)));
  } //;
}

